
#include <stdio.h>

#include "MyFilter.h"
#include "BitmapDrawer.h"

/*******************************************************
*   This is our Hook that gets called by the app
*******************************************************/
MyFilter *instantiate_filter() {
	return new MyFilter();
}

/*******************************************************
*   Consturctor
*   If you want to make a addon thats kewl, but we use
*   the ID value to identify between filters. So all
*   the built in filters are less than 101. So your 
*   filter should be greater than this. Now if you want
*   to make shur that your filter does not confilct with
*   someones elses I ask that you send me you ID code and
*   the compiled filter.  You can send me the source but
*   it is not required. (source is good though :)
*******************************************************/
MyFilter::MyFilter() : ImageFilter() {
	id = 101;  // this is our Identifyer.
	strcpy(name, "MyFilter"); // Our name
}

/*******************************************************
*   Distructor
*******************************************************/
MyFilter::~MyFilter() {

}

/*******************************************************
*   The heart to the operation.
*******************************************************/
BBitmap *MyFilter::Run(BBitmap *img) {
   if (img == NULL) return NULL; // make shur we have a image
   BRect b = img->Bounds();
   BRect rect(0,0,b.right,b.bottom);
   BBitmap *new_img = new BBitmap(rect,img->ColorSpace()); // creat the new image

   BitmapDrawer I(img); // niffty BitmapDrawers that make life easyer
   BitmapDrawer NI(new_img);

   int32 x,y;
   rgb_color c;
   for(y=0;y <= b.IntegerHeight(); y++){
      for(x=0;x <= b.IntegerWidth(); x++){     
         I.GetPixel(x,y,&c);
         // Do something spiffy here!
         NI.SetPixel(x,y,c);
      }
   }
   return new_img;
}


